#include "TFT_R61505.h"


void _delay_ms(unsigned int p)
{
 	static unsigned int i,j=0;
	for (j=0;j<p;j++)
	{
		for (i=0;i<50;i++);
	}
	return;
}

void TFT_port_init (void)
{
// 	FIO1DIR|= _BV(TFT_FMARK);
//	FIO1SET|= _BV(TFT_FMARK);

 	FIO1DIR|= _BV(TFT_CS);
	FIO1SET|= _BV(TFT_CS);

 	FIO1DIR|= _BV(TFT_RS);
	FIO1SET|= _BV(TFT_RS);

 	FIO1DIR|= _BV(TFT_WR);
	FIO1SET|= _BV(TFT_WR);

 	FIO1DIR|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_RD);

 	FIO1DIR|= _BV(TFT_RESET);
	FIO1CLR|= _BV(TFT_RESET);

	FIO2DIR|= 0x000000ff;
   	FIO2CLR|= 0x000000ff;
	return;
}

void TFT_reset (void)
{
	
	FIO1CLR|= _BV(TFT_RESET); 

	FIO1SET|= _BV(TFT_RESET); 
	delay(1000);

	return;
}

void TFT_write_com (unsigned int data)	
{
	unsigned char data_up=0,data_low=0;

	FIO1CLR|= _BV(TFT_CS); //  

	FIO1CLR|= _BV(TFT_RS);	//  
	
	FIO1SET|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_WR);

	data_up=(data&0xff00)>>8;
	data_low=(data&0x00ff);

	FIO2CLR|=0x000000ff;	//    

//----------------------------------------------------
 //  
	FIO2SET|=(0x000000ff&data_up);

	FIO1CLR|= _BV(TFT_WR);  // 

	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------

	FIO2CLR|=0x000000ff;	// 

//----------------------------------------------------
  //  
	FIO2SET|=(0x000000ff&data_low);

	FIO1CLR|= _BV(TFT_WR);  // 

	FIO1SET|= _BV(TFT_WR);	// 

	FIO1SET|= _BV(TFT_RS);	//  

	FIO1SET|= _BV(TFT_CS); //  

	return;
}

void TFT_write_dat (unsigned int data)	
{
	unsigned char data_up=0,data_low=0;

	FIO1CLR|= _BV(TFT_CS); //  

	FIO1SET|= _BV(TFT_RS);	//  
	
	FIO1SET|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_WR);

	data_up=(data&0xff00)>>8;
	data_low=(data&0x00ff);

	FIO2CLR|=0x000000ff;	// 
//----------------------------------------------------
 //  
	FIO2SET|=(0x000000ff&data_up);

	FIO1CLR|= _BV(TFT_WR);  // 

	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------
	FIO2CLR|=0x000000ff;	// 
//----------------------------------------------------
  //  
	FIO2SET|=(0x000000ff&data_low);

	FIO1CLR|= _BV(TFT_WR);  // 

	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------
	FIO1SET|= _BV(TFT_RS);	//  

	FIO1SET|= _BV(TFT_CS); //  

	return;
}

	
void TFT_Write_Register  (unsigned char ir,unsigned int data)	
{
	FIO1CLR|=_BV(TFT_CS);  // LCD
	FIO1CLR|=_BV(TFT_RS);  //   LCD

	FIO2CLR|=0x000000ff;	//  

	FIO1CLR|=_BV(TFT_WR); //    LCD
	FIO1SET|=_BV(TFT_WR); //    LCD

	FIO2CLR|=0x000000ff;	//  
	FIO2SET|=ir;			 // 
	
	FIO1CLR|=_BV(TFT_WR); //    LCD
	FIO1SET|=_BV(TFT_WR); //    LCD	
	
	                          
	FIO1SET|=_BV(TFT_RS);    //   LCD

	FIO2CLR|=0x000000ff;	//  
	FIO2SET|=data>> 8;      //  

	FIO1CLR|=_BV(TFT_WR); //    LCD
	FIO1SET|=_BV(TFT_WR); //    LCD	

	FIO2CLR|=0x000000ff;	//  
	FIO2SET|=0xff&data;           //               
    
	FIO1CLR|=_BV(TFT_WR); //    LCD
	FIO1SET|=_BV(TFT_WR); //    LCD	                        

 	FIO1SET|=_BV(TFT_CS);//  LCD

}



void TFT_init(void)
{

   	FIO1CLR|= _BV(TFT_RESET); 
	_delay_ms(400);
   	FIO1SET|= _BV(TFT_RESET); 

	//initializing function 2

	TFT_Write_Register (0x30,0x0204);
	TFT_Write_Register (0x31,0x0001);
	TFT_Write_Register (0x32,0x0000);
	TFT_Write_Register (0x35,0x0206);
	TFT_Write_Register (0x36,0x0600);
	TFT_Write_Register (0x37,0x0500);
	TFT_Write_Register (0x38,0x0505);
	TFT_Write_Register (0x39,0x0407);
	TFT_Write_Register (0x3c,0x0500);
	TFT_Write_Register (0x3d,0x0503);

	//display on
	TFT_Write_Register (0x07,0x0173); 


	TFT_Write_Register ( 0x00, 0x0000 );
	TFT_Write_Register ( 0x00, 0x0000 );
	TFT_Write_Register ( 0x00, 0x0000 );
	TFT_Write_Register ( 0x00, 0x0000 );
	
//	TFT_Write_Register ( 0xa4, 0x0001 );
	TFT_Write_Register ( 0x00, 0x0001 );
//	TFT_Write_Register ( 0x12, 0x0180 );
	TFT_Write_Register ( 0x07, 0x0001 );
	TFT_Write_Register ( 0x17, 0x0001 );
	_delay_ms(2);

	TFT_Write_Register ( 0x60, 0x2700 );
	TFT_Write_Register ( 0x08, 0x0808 );

	TFT_Write_Register ( 0x30, 0x0000 );
	TFT_Write_Register ( 0x31, 0x1103 );
	TFT_Write_Register ( 0x32, 0x0903 );
	TFT_Write_Register ( 0x33, 0x0205 );
	TFT_Write_Register ( 0x34, 0x0100 );
	TFT_Write_Register ( 0x35, 0x0401 );
	TFT_Write_Register ( 0x36, 0x1309 );
	TFT_Write_Register ( 0x37, 0x0301 );
	TFT_Write_Register ( 0x38, 0x0200 );
	TFT_Write_Register ( 0x39, 0x0310 );
	
	TFT_Write_Register ( 0x90, 0x001E );
	
	TFT_Write_Register ( 0x17, 0x0001 );
	TFT_Write_Register ( 0x10, 0x0530 );
	TFT_Write_Register ( 0x11, 0x0237 );
	TFT_Write_Register ( 0x12, 0x11B8 );
	_delay_ms(150);
	TFT_Write_Register ( 0x13, 0x0f00 );
	
	TFT_Write_Register ( 0x01, 0x0000 );
	TFT_Write_Register ( 0x02, 0x0200 );
	TFT_Write_Register ( 0x03, 0x1030 );
	TFT_Write_Register ( 0x09, 0x0001 );
	TFT_Write_Register ( 0x0a, 0x0000 );
	TFT_Write_Register ( 0x0c, 0x0000 );
	TFT_Write_Register ( 0x0d, 0x0000 );
	TFT_Write_Register ( 0x0e, 0x0000 );
	TFT_Write_Register ( 0x0f, 0x0000 );

	TFT_Write_Register ( 0x50, 0x0000 );
	TFT_Write_Register ( 0x51, 0x00ef );
	TFT_Write_Register ( 0x52, 0x0000 );
	TFT_Write_Register ( 0x53, 0x013f );
	
	TFT_Write_Register ( 0x61, 0x0000 );
	TFT_Write_Register ( 0x6a, 0x0000 );
	
	TFT_Write_Register ( 0x80, 0x0000 );
	TFT_Write_Register ( 0x81, 0x0000 );
	TFT_Write_Register ( 0x82, 0x0000 );
	
	TFT_Write_Register ( 0x91, 0x0000 );
	TFT_Write_Register ( 0x92, 0x0100 );
	TFT_Write_Register ( 0x93, 0x0001 );
	TFT_Write_Register ( 0x94, 0x0001 );
	TFT_Write_Register ( 0x95, 0x001f );
	TFT_Write_Register ( 0x96, 0x0001 );
	TFT_Write_Register ( 0x97, 0x0100 );
	TFT_Write_Register ( 0x98, 0x0001 );
	TFT_Write_Register ( 0x99, 0x0001 );
	TFT_Write_Register ( 0x9c, 0x0043 );
	
	TFT_Write_Register ( 0x20, 0x0000 );
	TFT_Write_Register ( 0x21, 0x0000 );
	
	TFT_Write_Register ( 0x22, 0x0000 );

	TFT_Write_Register ( 0x07, 0x0173 );

}	


void TFT_set_window(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned char rot)
{
 if(rot == 0)                                        //  ,  
  {
   TFT_Write_Register (HORIZONTAL_ADDRESS_SET, x1);                    //   LCD
   TFT_Write_Register (VERTICAL_ADDRESS_SET, y1);                         //   LCD

   TFT_Write_Register (WINDOW_HORIZONTAL_ADDRESS_START, x1);          //   LCD
   TFT_Write_Register (WINDOW_HORIZONTAL_ADDRESS_END, x2);               //   LCD
   TFT_Write_Register (WINDOW_VERTICAL_ADDRESS_START, y1);               //   LCD
   TFT_Write_Register (WINDOW_VERTICAL_ADDRESS_END, y2);               //   LCD
  }
 else                                                                      // 
  {
   TFT_Write_Register (HORIZONTAL_ADDRESS_SET, y1);                    //   LCD
   TFT_Write_Register (VERTICAL_ADDRESS_SET, SCREEN_HEIGHT-x1-1);     //   LCD

   TFT_Write_Register (WINDOW_HORIZONTAL_ADDRESS_START, y1);                         //   LCD
   TFT_Write_Register (WINDOW_HORIZONTAL_ADDRESS_END, y2);                              //   LCD
   TFT_Write_Register (WINDOW_VERTICAL_ADDRESS_START, SCREEN_HEIGHT-x2-1);          //   LCD
   TFT_Write_Register (WINDOW_VERTICAL_ADDRESS_END, SCREEN_HEIGHT-x1-1);          //   LCD
  }
}


//----------------------------------------------------------------------------------------------
// :     
// :     
// :  
//----------------------------------------------------------------------------------------------
void TFT_set_direction(unsigned char rot,unsigned char direction)
{
 if(rot == 0)                    //  ,  
  {
   if(direction == 1)                     //  ,  
    {
    // Direction = 1;                      //  
     TFT_Write_Register (ENTRY_MODE, 0x1030);          //   LCD
    }
   else                                                  // 
    {
    // Direction = 0;                      //  
     TFT_Write_Register (ENTRY_MODE, 0x1038);          //   LCD
     }
  }
 else                                                   // 
  {
   if(direction == 1)                     //  ,  
    {
    // Direction = 1;                      //  
     TFT_Write_Register (ENTRY_MODE, 0x1018);          //   LCD
    }
   else                                                  // 
    {
     //Direction = 0;                      //  
     TFT_Write_Register (ENTRY_MODE, 0x1010);          //   LCD
     }
  }
}

//----------------------------------------------------------------------------------------------
// :    LCD  
// :   
// :  
//----------------------------------------------------------------------------------------------
void TFT_fill_screen(unsigned int color)
{
 unsigned int counter1,counter2=0; 

 FIO1CLR |= _BV(TFT_CS);                         // LCD
 FIO1CLR |= _BV(TFT_RS);                         //   LCD
 FIO2CLR|=0x000000ff;	// 
  
 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD

 //FIO2CLR|=0x000000ff;	// 
 FIO2SET|= WRITE_DATA_RAM;                     // 

 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD

 FIO1SET |= _BV(TFT_RS);                         //   LCD

  for(counter1 = 0; counter1 < SCREEN_WIDTH; counter1++)     //   LCD      
  {
    for(counter2 = 0; counter2 < SCREEN_HEIGHT; counter2++)     //   LCD  
	{
  	   FIO2CLR|=0x000000ff;	// 
	   FIO2SET|=  color >> 8; 
	
	   FIO1CLR |= _BV(TFT_WR);                         //    LCD
	   FIO1SET |= _BV(TFT_WR);                          //    LCD
	
	   FIO2CLR|=0x000000ff;	// 
	   FIO2SET|=  color;							    //  
	                     
	   FIO1CLR |= _BV(TFT_WR);                         //    LCD
	   FIO1SET |= _BV(TFT_WR);                          //    LCD
	 }
  }

 FIO1SET |= _BV(TFT_CS);                          //  LCD
}

//----------------------------------------------------------------------------------------------
// :   
// :  x,
//             y,
//              
// :  
//----------------------------------------------------------------------------------------------
void TFT_set_pixel(unsigned int x, unsigned int y, unsigned int color,unsigned char rot)
{
 TFT_set_window(x, y, x, y, rot);               //    RAM LCD

 FIO1CLR |= _BV(TFT_CS);                         // LCD
 FIO1CLR |= _BV(TFT_RS);                          //   LCD

 FIO2CLR|=0x000000ff;	//                             // 
 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD

 //FIO2CLR|=0x000000ff;	// 
 FIO2SET|= WRITE_DATA_RAM;                     // 

 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD


 FIO1SET |= _BV(TFT_RS);                         //   LCD

 FIO2CLR|=0x000000ff;	// 
 FIO2SET|=  color >> 8; 
	
 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD
	
 FIO2CLR|=0x000000ff;	// 
 FIO2SET|=  color;							    //  
	                     
 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD


 FIO1SET |= _BV(TFT_CS);                          //  LCD
}

//----------------------------------------------------------------------------------------------
// :     
// :   color_background,
//              color_imposed,
//               
// :    
//----------------------------------------------------------------------------------------------
unsigned int lcd_mixed_colors(unsigned int color_background,unsigned int color_imposed,unsigned char opacity)
{
 unsigned char r_background, g_background, b_background;
 unsigned char r_imposed, g_imposed, b_imposed;
 unsigned char r, g, b;
/*
 if(color_imposed == NONE)
  return color_background;
*/
 r_background = (color_background & 0xF800) >> 11;
 g_background = (color_background & 0x07E0) >> 5;
 b_background = color_background & 0x001F;

 r_imposed = (color_imposed & 0xF800) >> 11;
 g_imposed = (color_imposed & 0x07E0) >> 5;
 b_imposed = color_imposed & 0x001F;

 r = r_background - opacity*(r_background - r_imposed)/100;
 g = g_background - opacity*(g_background - g_imposed)/100;
 b = b_background - opacity*(b_background - b_imposed)/100;

 return ((r << 11) | (g << 5) | b);
}

//----------------------------------------------------------------------------------------------
// :    
// :     x1,
//                y1,
//                x2,
//                y2,
//             
// :  
//----------------------------------------------------------------------------------------------
void TFT_fill_rect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, 
                   unsigned int bg_color, unsigned int fg_color, unsigned char opacity, unsigned char rot)
{
unsigned int color = lcd_mixed_colors(bg_color, fg_color, opacity);

unsigned int y,x;

 TFT_set_window(x1, y1, x2, y2, rot);               //    RAM LCD

 FIO1CLR |= _BV(TFT_CS);                         // LCD
 FIO1CLR |= _BV(TFT_RS);                         //   LCD

 FIO2CLR|=0x000000ff;	// 
  
 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD

 //FIO2CLR|=0x000000ff;	// 
 FIO2SET|= WRITE_DATA_RAM;                     // 

 FIO1CLR |= _BV(TFT_WR);                         //    LCD
 FIO1SET |= _BV(TFT_WR);                          //    LCD

 FIO1SET |= _BV(TFT_RS);                         //   LCD

 for(y = y1; y <= y2; y++)             //   y
  for(x = x1; x <= x2; x++)            //   x
  {
  	FIO2CLR|=0x000000ff;	// 
	FIO2SET|=  color >> 8; 
	
	FIO1CLR |= _BV(TFT_WR);                         //    LCD
	FIO1SET |= _BV(TFT_WR);                          //    LCD
	
	FIO2CLR|=0x000000ff;	// 
	FIO2SET|=  color;							    //  
	                     
	FIO1CLR |= _BV(TFT_WR);                         //    LCD
	FIO1SET |= _BV(TFT_WR);                          //    LCD
  }

 FIO1SET |= _BV(TFT_CS);                       //  LCD
}

void TFT_Rectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b,unsigned int color, unsigned char rot)
{
	unsigned char j=0;

  for (j = 0; j < a; j++) {
		TFT_set_pixel(x, y + j,color,rot);
		TFT_set_pixel(x + b - 1, y + j,color,rot);
	}
  for (j = 0; j < b; j++)	{
		TFT_set_pixel(x + j, y,color,rot);
		TFT_set_pixel(x + j, y + a - 1,color,rot);
	}
	  return;	
}

void TFT_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color, unsigned char rot)//==================// 
{
  int x, y, xchange, ychange, radiusError;
  x = radius;
  y = 0;
  xchange = 1 - 2 * radius;
  ychange = 1;
  radiusError = 0;
  while(x >= y)
  {
    TFT_set_pixel(cx+x, cy+y, color, rot); 
    TFT_set_pixel(cx-x, cy+y, color, rot); 
    TFT_set_pixel(cx-x, cy-y, color, rot);
    TFT_set_pixel(cx+x, cy-y, color, rot); 
    TFT_set_pixel(cx+y, cy+x, color, rot); 
    TFT_set_pixel(cx-y, cy+x, color, rot); 
    TFT_set_pixel(cx-y, cy-x, color, rot); 
    TFT_set_pixel(cx+y, cy-x, color, rot); 
    y++;
    radiusError += ychange;
    ychange += 2;
    if ( 2*radiusError + xchange > 0 )
    {
      x--;
      radiusError += xchange;
      xchange += 2;
    }
  }
}


//======================================================================================================================
void TFT_Line(int x1, int y1, int x2, int y2, unsigned int color, unsigned char rot)//===========================================================// 
{
  int dx = (x2 - x1 >= 0 ? 1 : -1);
  int dy = (y2 - y1 >= 0 ? 1 : -1);
  
  int lengthX,lengthY,length;
  
//==============================================================       
  if (x2>=x1) {lengthX=x2-x1;} else  {lengthX=x1-x2;}     
  if (y2>=y1) {lengthY=y2-y1;} else  {lengthY=y1-y2;}
  if (lengthX > lengthY){length=lengthX;} else {length=lengthY;} 
//==============================================================   
  
  if (length == 0)
  {
    TFT_set_pixel(x1, y1, color,rot);
  }
  
  if (lengthY <= lengthX)
  {
    //------------------  -------------------//
    int x = x1;
    int y = y1;
    int d = -lengthX;
    
    //------------------   -----------------------//
    length++;
    while(length--)
    {
      TFT_set_pixel(x, y, color,rot);
      x += dx;
      d += 2 * lengthY;
      if (d > 0) {
        d -= 2 * lengthX;
        y += dy;
      }
    }
  }
  else
  {
    //------------------  -------------------//
    int x = x1;
    int y = y1;
    int d = - lengthY;
    
    //------------------  ------------------------//
    length++;
    while(length--)
    {
      TFT_set_pixel(x, y, color,rot);
      y += dy;
      d += 2 * lengthX;
      if (d > 0) {
        d -= 2 * lengthY;
        x += dx;
      }
    }
  }
}

