#include"common.h"

// PORT1
#define TFT_FMARK	31
#define	TFT_CS		0
#define	TFT_RS		4
#define	TFT_WR		1
#define TFT_RD		9
#define	TFT_RESET	8


#define SCREEN_HEIGHT	320
#define SCREEN_WIDTH	240

#define DEVICE_CODE_READ                            0x00
#define DRIVER_OUTPUT_CONTROL_1                     0x01
#define DRIVING_WAVE_CONTROL                        0x02
#define ENTRY_MODE                                  0x03
#define RESIZING_CONTROL                            0x04
#define DISPLAY_CONTROL_1                           0x07
#define DISPLAY_CONTROL_2                           0x08
#define DISPLAY_CONTROL_3                           0x09
#define DISPLAY_CONTROL_4                           0x0A
#define EXTERNAL_DISPLAY_INTERFACE_CONTROL_1        0x0C
#define FRAME_MARKER_POSITION                       0x0D
#define VCOM_LOW_POWER_CONTROL                      0x0E
#define EXTERNAL_DISPLAY_INTERFACE_CONTROL_2        0x0F
#define POWER_CONTROL_1                               0x10
#define POWER_CONTROL_2                               0x11
#define POWER_CONTROL_3                               0x12
#define POWER_CONTROL_4                               0x13
#define POWER_CONTROL_5                               0x17
#define POWER_CONTROL_6                               0x19
#define HORIZONTAL_ADDRESS_SET                        0x20
#define VERTICAL_ADDRESS_SET                          0x21
#define WRITE_DATA_RAM                                   0x22
#define READ_DATA_RAM                                    0x22
#define NVM_READ_DATA                                0x28
#define VCOM_HIGH_VOLTAGE_1                          0x29
#define VCOM_HIGH_VOLTAGE_2                           0x2A
#define GAMMA_CONTROL_1                               0x30 
#define GAMMA_CONTROL_2                               0x31
#define GAMMA_CONTROL_3                               0x32
#define GAMMA_CONTROL_4                               0x33
#define GAMMA_CONTROL_5                               0x34
#define GAMMA_CONTROL_6                               0x35
#define GAMMA_CONTROL_7                               0x36
#define GAMMA_CONTROL_8                               0x37
#define GAMMA_CONTROL_9                               0x38
#define GAMMA_CONTROL_10                               0x39
#define GAMMA_CONTROL_11                               0x3A
#define GAMMA_CONTROL_12                               0x3B
#define GAMMA_CONTROL_13                               0x3C
#define GAMMA_CONTROL_14                               0x3D
#define WINDOW_HORIZONTAL_ADDRESS_START              0x50
#define WINDOW_HORIZONTAL_ADDRESS_END                0x51
#define WINDOW_VERTICAL_ADDRESS_START                0x52
#define WINDOW_VERTICAL_ADDRESS_END                0x53
#define DRIVER_OUTPUT_CONTROL_2                    0x60
#define BASE_IMAGE_CONTROL                         0x61
#define VERTICAL_SCROLL_CONTROL                    0x6A
#define PARTIAL_IMAGE_1_DISPLAY_POSITION           0x80
#define PARTIAL_IMAGE_1_RAM_START_LINE_ADDRESS     0x81
#define PARTIAL_IMAGE_1_RAM_END_LINE_ADDRESS       0x82
#define PARTIAL_IMAGE_2_DISPLAY_POSITION           0x83
#define PARTIAL_IMAGE_2_RAM_START_LINE_ADDRESS     0x84
#define PARTIAL_IMAGE_2_RAM_END_LINE_ADDRESS       0x85
#define PANEL_INTERFACE_CONTROL_1                     0x90
#define PANEL_INTERFACE_CONTROL_2                     0x92
#define PANEL_INTERFACE_CONTROL_3                     0x93
#define PANEL_INTERFACE_CONTROL_4                     0x95
#define PANEL_INTERFACE_CONTROL_5                     0x97
#define PANEL_INTERFACE_CONTROL_6                     0x98
#define NVM_ACCESS_CONTROL_1                          0xA0
#define NVM_ACCESS_CONTROL_2                          0xA1
#define CALIBRATION_CONTROL                           0xA4


#define G_BLACK       0x0000
#define G_RED         0xf800
#define G_GREEN       0x07e0
#define G_YELLOW      0xffe0
#define G_BLUE        0x001f
#define G_MAGENTA     0xf81f
#define G_CYAN        0x07ff
#define G_WHITE       0xffff
/* Names for extended colors */
#define G_LLIGHTGREY  0xd6ba
#define G_LIGHTGREY   0xbdf7
#define G_GREY        0xad75
#define G_DARKGREY    0x94b2
#define G_DDARKGREY   0x7bef
#define G_DARKBLUE    0x0018
#define G_ORANGE      0xfc00


void _delay_ms(unsigned int p);
void TFT_port_init (void);
void TFT_reset (void);

void TFT_init(void);
void TFT_write_com (unsigned int data);
void TFT_write_dat (unsigned int data);

void TFT_Write_Register (unsigned char ir,unsigned int data);
void TFT_set_window(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned char rot);
void TFT_set_direction(unsigned char rot,unsigned char direction);
void TFT_fill_screen(unsigned int color);
void TFT_set_pixel(unsigned int x, unsigned int y, unsigned int color,unsigned char rot);

void TFT_fill_rect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, 
                   unsigned int bg_color, unsigned int fg_color, unsigned char opacity, unsigned char rot);
				   	
void TFT_Rectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b,unsigned int color, unsigned char rot);
void TFT_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color, unsigned char rot);

void TFT_Line(int x1, int y1, int x2, int y2, unsigned int color, unsigned char rot);

