#include "LS020.h"

/*-----------   LS020 ---------------------------------------------------------------------------------------------*/
const unsigned int  INIT0[2] ={0xFDFD,0xFDFD};
const unsigned int  INIT1[5] ={0xEF00,0xEE04,0x1B04,0xFEFE,0xFEFE};
const unsigned int  INIT2[5] ={0xEF90,0x4A04,0x7F3F,0xEE04,0x4306};	                                             //16k color
//const unsigned int  INIT2[5] ={0xEF90,0x4A04,0x7F1F,0xEE04,0x4306};                                                  //256color
const unsigned int  INIT3[10]={0xEF90,0x0983,0x0800,0x0BAF,0x0A00,0x0500,0x0600,0x0700,0xEF00,0xEE0C}; 
const unsigned int  INIT4[6] ={0xEF90,0x0080,0xEFB0,0x4902,0xEF00,0x7F01};
const unsigned int  INIT5[1] ={0xE181};
const unsigned int  INIT6[1] ={0xE202};
const unsigned int  INIT7[1] ={0xE276};
const unsigned int  INIT8[2] ={0xE183,0x8001};
const unsigned int  INIT9[2] ={0xEF90,0x0000};
const unsigned int  INIT10[4]={0xEF90,0x0500,0x0600,0x0700};
/*---------------------------------------------------------------------------------------*/


void SPI_Init(void)// SPI
{
	FIO0DIR|= _BV(LCD_CS)|_BV(LCD_MISO)|_BV(LCD_SCK)|_BV(LCD_RES)|_BV(LCD_RS)|_BV(LCD_MOSI);	//  SPI - 

	FIO0CLR|=  _BV(LCD_CS)|_BV(LCD_MISO)|_BV(LCD_SCK)|_BV(LCD_RES)|_BV(LCD_RS)|_BV(LCD_MOSI);	//  SPI - .0


	//    SPI0			
	PINSEL1|= _BV(1) | _BV(3) | _BV(5); //   SPI
	PINSEL0|= _BV(31);

	PINSEL1&=~_BV(0)& ~_BV(2)& ~_BV(4);   //   SPI
	PINSEL0&= ~_BV(30);

	//  SPI
	SSP0CPSR = 0x02;    // SCK = 1 MHz, counter > 8 and even
	SSP0CR0  = 0x07; // CPHA=1, CPOL=0, master mode, MSB first, interrupt enabled
	SSP0CR1  = 0x02; // CPHA=1, CPOL=0, master mode, MSB first, interrupt enabled
}


void LCD_Write16(unsigned int lcd_data)
{ 
	SSP0DR = lcd_data>>8; 
	while ((SSP0SR & (1 << 0)) == 0){;}
	SSP0DR = lcd_data&0x00FF;
	while ((SSP0SR & (1 << 0)) == 0){;}
}
//======================================================================================================================================
void LCD_Write8(unsigned char lcd_data)
{ 
	SSP0DR = lcd_data;
	while ((SSP0SR & (1 << 0)) == 0){;}
}
//======================================================================================================================================
 
void delaySF_ms(unsigned int sleep)
{
	unsigned int _del;
	_del = 0x0F;
	while (_del>0) 
	_del--;
	 
}
//======================================================================================================================================

void delay_ms(unsigned int sleep)
{
	unsigned int _del, _del2;
	_del2 = sleep;
	while (_del2 > 0){
	_del = 0x2FFF;
	while (_del>0) 
	_del--;
	 _del2--;
}

}

//======================================================================================================================================
void LCD_SetCommand()                                                                                   //   
{
	highCS;
	delaySF_ms(1);
	lowCS;
	highRS;  
} 

//======================================================================================================================================
void LCD_SetData()                                                                                      //   
{
	highCS;
	delaySF_ms(1);
	lowCS;
	lowRS;  
} 
  
//======================================================================================================================================
volatile void Init_LCD(void)                                                                                     // 
{
	unsigned char cnt;
   	lowRES;
	lowRS;
	delay_ms(10);
    highRES;
	highCS;
	delay_ms(10);
	highRS;
	delay_ms(10);
	lowCS;
	delay_ms(10);
	 
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT0[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<5;cnt++) 
	LCD_Write16(INIT1[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<5;cnt++) 
	LCD_Write16(INIT2[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<10;cnt++) 
	LCD_Write16(INIT3[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<6;cnt++) 
	LCD_Write16(INIT4[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT5[cnt]);
	delay_ms(10);
    for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT6[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<1;cnt++) 
	LCD_Write16(INIT7[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT8[cnt]);
	delay_ms(10);
	for (cnt=0;cnt<2;cnt++) 
	LCD_Write16(INIT9[cnt]);
	highCS;
}

