#include"common.h"

//  
#define LCD_CS 		16
#define LCD_MISO 	17
#define LCD_MOSI	18
#define LCD_SCK		15
#define LCD_RES		19
#define LCD_RS		20

//  
#define highCS 		FIO0SET = (1 << 16)
#define lowCS		FIO0CLR = (1 << 16)
#define highRES		FIO0SET = (1 << 19)
#define lowRES      FIO0CLR = (1 << 19)
#define highRS		FIO0SET = (1 << 20)
#define lowRS      	FIO0CLR = (1 << 20)

#define DISP_W 132
#define DISP_H 176

#define CHAR_H 14
#define CHAR_W 8

#define TEXT_COL 16
#define TEXT_ROW 12

#define   RGB(r,g,b)    ((r & 0x1F) << 11) + ((g & 0x3F) << 5) + (b & 0x1F)
#define   RGB_GREEN     RGB(0,63,0)
#define   RGB_BLUE      RGB(0,0,31)
#define   RGB_RED       RGB(31,0,0)
#define   RGB_GREEY     RGB(20,20,20)
#define   RGB_YELLOW    0xDEE0
#define   RGB_ORANGE    0xAB00
#define   RGB_PINK      0xF97F
#define   RGB_BROWN     0x8200
#define   RGB_GREY      0x8410
#define   RGB_VIOLET    0x91D4
#define   RGB_WHITE     0xFFFF
#define   RGB_BLACK     0x0000

void LCD_Write8(unsigned char lcd_data);
void LCD_Write16(unsigned int lcd_data);
void LCD_SetCommand(void);                                                                      //   
void LCD_SetData(void);                                                                         //   
volatile void Init_LCD(void);                                                                   // 
void SPI_Init(void);                                                                           // SPI
void delay_ms(unsigned int sleep);
void delaySF_ms(unsigned int sleep);



