#include "graph.h"
#include "font_x65_5x7.h"

//=================================================================================================
void LCD_FillRect(unsigned char stX,unsigned char stY,unsigned char lngX,unsigned char lngY)//  
{
	LCD_SetCommand();
	LCD_Write16(0xEF90);
	LCD_Write16(0x0500);
	LCD_Write16((0x08<<8)+stY);
	lngY+=stY;
	LCD_Write16((0x09<<8)+lngY);
	LCD_Write16((0x0A<<8)+stX);
  	lngX+=stX;
	LCD_Write16((0x0B<<8)+lngX);
}

//===============================================================================================
void LCD_FillScr(unsigned int color)//================================//   
{
  unsigned int i=0;

  LCD_SetCommand();

  LCD_Write16(0xEF90);
  LCD_Write16(0x0500);
  LCD_Write16(0x0600);
  LCD_Write16(0x0700);

  LCD_SetData();  

  for (i=0; i<DISP_W*DISP_H; i++) LCD_Write16(color);  
}
//===============================================================================================
 void LCD_FilScr(const unsigned char * Buff)//=========================//   
{
    unsigned int cnt;
   // LCD_FillRect(0,0,9,15); 
    LCD_SetData();
    for (cnt=0; cnt<10*16; cnt++) {
    LCD_Write8(*(Buff++));
    }
}  
//==========================================================================================================
void LCD_PutPixel(unsigned char X1,unsigned char Y1,unsigned int color)//==========//   
{
	LCD_SetCommand();
	LCD_Write16(0xEF90);
	LCD_Write16(0x0504);  
	LCD_Write16((0x06<<8)+Y1);
	LCD_Write16((0x07<<8)+X1);
	LCD_SetData();
	LCD_Write16(color);
 
} 
void LCD_Rectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b,unsigned int color)
{
	unsigned char j=0;

  for (j = 0; j < a; j++) {
		LCD_PutPixel(x, y + j,color);
		LCD_PutPixel(x + b - 1, y + j,color);
	}
  for (j = 0; j < b; j++)	{
		LCD_PutPixel(x + j, y,color);
		LCD_PutPixel(x + j, y + a - 1,color);
	}
	  return;	
}

//=======================================================================================================================
void LCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius,unsigned color)//==================// 
{
  int x, y, xchange, ychange, radiusError;
  x = radius;
  y = 0;
  xchange = 1 - 2 * radius;
  ychange = 1;
  radiusError = 0;
  while(x >= y)
  {
    LCD_PutPixel(cx+x, cy+y, color); 
    LCD_PutPixel(cx-x, cy+y, color); 
    LCD_PutPixel(cx-x, cy-y, color);
    LCD_PutPixel(cx+x, cy-y, color); 
    LCD_PutPixel(cx+y, cy+x, color); 
    LCD_PutPixel(cx-y, cy+x, color); 
    LCD_PutPixel(cx-y, cy-x, color); 
    LCD_PutPixel(cx+y, cy-x, color); 
    y++;
    radiusError += ychange;
    ychange += 2;
    if ( 2*radiusError + xchange > 0 )
    {
      x--;
      radiusError += xchange;
      xchange += 2;
    }
  }
}


//======================================================================================================================
void LCD_Line(int x1, int y1, int x2, int y2, unsigned int color)//===========================================================// 
{
  int dx = (x2 - x1 >= 0 ? 1 : -1);
  int dy = (y2 - y1 >= 0 ? 1 : -1);
  
  int lengthX,lengthY,length;
  
//==============================================================       
  if (x2>=x1) {lengthX=x2-x1;} else  {lengthX=x1-x2;}     
  if (y2>=y1) {lengthY=y2-y1;} else  {lengthY=y1-y2;}
  if (lengthX > lengthY){length=lengthX;} else {length=lengthY;} 
//==============================================================   
  
  if (length == 0)
  {
    LCD_PutPixel(x1, y1, color);
  }
  
  if (lengthY <= lengthX)
  {
    //------------------  -------------------//
    int x = x1;
    int y = y1;
    int d = -lengthX;
    
    //------------------   -----------------------//
    length++;
    while(length--)
    {
      LCD_PutPixel(x, y, color);
      x += dx;
      d += 2 * lengthY;
      if (d > 0) {
        d -= 2 * lengthX;
        y += dy;
      }
    }
  }
  else
  {
    //------------------  -------------------//
    int x = x1;
    int y = y1;
    int d = - lengthY;
    
    //------------------  ------------------------//
    length++;
    while(length--)
    {
      LCD_PutPixel(x, y, color);
      y += dy;
      d += 2 * lengthX;
      if (d > 0) {
        d -= 2 * lengthY;
        x += dx;
      }
    }
  }
}
//======================================================================================


void put_char(unsigned char x, unsigned char y, unsigned char c,unsigned int text_color,unsigned int back_color, unsigned char rot)
{
  unsigned char h,ch,p,mask;

  LCD_SetCommand();

  LCD_Write16(0xEF90);

  if (rot)
  {
    LCD_Write16(0x0500);
    LCD_Write16(0x0800+x);
    LCD_Write16(0x0A00+y);
    LCD_Write16(0x0900+x+CHAR_W-1);
    LCD_Write16(0x0B00+y+CHAR_H-1);
  }
  else
  {
    LCD_Write16(0x0504);
    LCD_Write16(0x0800+y);
    LCD_Write16(0x0A00+x);
    LCD_Write16(0x0900+y+CHAR_H-1);
    LCD_Write16(0x0B00+x+CHAR_W-1);
  }
  
  for (h=0; h<CHAR_H; h++) // every column of the character
  {
        if (rot)   ch=ascii_tab[ c ][h];	
    
		else  ch=ascii_tab[ c ][CHAR_H-h-1];
          
        mask=0x80;

		LCD_SetData();

        for (p=0; p<CHAR_W; p++)  // write the pixels
        {
          if (ch&mask)	 LCD_Write16(text_color);

          else LCD_Write16(back_color);
										 
          mask=mask/2;
        }  // for p
  }
}


void gclcd_put_val_6dig(unsigned char pos_x, unsigned char pos_y, unsigned long val,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	
	put_char(pos_x,pos_y,(val/100000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+8,pos_y,((val%100000)/10000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+16,pos_y,((val%10000)/1000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+24,pos_y,((val/100)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+32,pos_y,((val/10)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+40,pos_y,(val%10 + 0x30), text_color, back_color, rot_);
}

void gclcd_put_val_5dig(unsigned char pos_x, unsigned char pos_y, unsigned int val,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	
	put_char(pos_x,pos_y,(val/10000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+8,pos_y,((val%10000)/1000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+16,pos_y,((val/100)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+24,pos_y,((val/10)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+32,pos_y,(val%10 + 0x30), text_color, back_color, rot_);
}

void gclcd_put_val_4dig(unsigned char pos_x, unsigned char pos_y, unsigned int val,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	put_char(pos_x,pos_y,(val/1000 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+8,pos_y,((val/100)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+16,pos_y,((val/10)%10 + 0x30), text_color, back_color, rot_);
	put_char(pos_x+24,pos_y,(val%10 + 0x30), text_color, back_color, rot_);
}

void gclcd_put_val_3dig(unsigned char pos_x,unsigned char pos_y,unsigned int val ,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	put_char(pos_x,pos_y,((val/100)%10 + 0x30),text_color, back_color, rot_);
	put_char(pos_x+8,pos_y,((val/10)%10 + 0x30),text_color, back_color, rot_);
	put_char(pos_x+16,pos_y,(val%10 + 0x30),text_color, back_color, rot_);
}
void gclcd_put_val_2dig(unsigned char pos_x,unsigned char pos_y,unsigned char val ,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	put_char(pos_x,pos_y,((val/10)%10 + 0x30),text_color, back_color, rot_);
	put_char(pos_x+8,pos_y,(val%10 + 0x30),text_color, back_color, rot_);
}
void gclcd_put_val_1dig(unsigned char pos_x,unsigned char pos_y,unsigned char val ,unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	put_char(pos_x,pos_y,(val%10 + 0x30),text_color, back_color, rot_);
}

void gclcd_put_txt (unsigned char pos_x,unsigned char pos_y,unsigned char txt[],unsigned int text_color,unsigned int back_color,unsigned char rot_)
{
	unsigned char i;
	i=0;
	while (txt[i]!=0)
	{
		put_char(pos_x+i*CHAR_W,pos_y,txt[i],text_color,back_color,rot_);   //  0 deg. rotated
		i++;
	}
} 
