#include "TFT_R61505.h"



void	TFT_port_init (void)
{
 	FIO1DIR|= _BV(TFT_FMARK);
	FIO1CLR|= _BV(TFT_FMARK);

 	FIO1DIR|= _BV(TFT_CS);
	FIO1SET|= _BV(TFT_CS);

 	FIO1DIR|= _BV(TFT_RS);
	FIO1SET|= _BV(TFT_RS);

 	FIO1DIR|= _BV(TFT_WR);
	FIO1SET|= _BV(TFT_WR);

 	FIO1DIR|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_RD);

 	FIO1DIR|= _BV(TFT_RESET);
	FIO1CLR|= _BV(TFT_RESET);

	FIO2DIR|= 0x000000ff;
   	FIO2CLR|= 0x000000ff;
	return;
}

void TFT_syncr (void)
{
	FIO1CLR|= _BV(TFT_CS); //  

	FIO1CLR|= _BV(TFT_RS);	//  
	
	FIO1SET|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_WR);


	FIO2CLR|=0x000000ff;	// 


 //  
	FIO2SET|=(0x000000ff&0x00);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (100);
	FIO1SET|= _BV(TFT_WR);	// 

  //  
	FIO2SET|=(0x000000ff&0x00);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (100);
	FIO1SET|= _BV(TFT_WR);	// 

	 //  
	FIO2SET|=(0x000000ff&0x00);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 

  //  
	FIO2SET|=(0x000000ff&0x00);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 

	FIO1SET|= _BV(TFT_RS);	//  

	FIO1SET|= _BV(TFT_CS); //  

}

void TFT_reset (void)
{
	
	FIO1CLR|= _BV(TFT_RESET); 
	TFT_syncr ();
	FIO1SET|= _BV(TFT_RESET); 
	delay(100000);

	return;
}	
void TFT_write_com (unsigned int data)	
{
	unsigned char data_up=0,data_low=0;

	FIO1CLR|= _BV(TFT_CS); //  

	FIO1CLR|= _BV(TFT_RS);	//  
	
	FIO1SET|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_WR);

	data_up=(data&0xff00)>>8;
	data_low=(data&0x00ff);

	FIO2CLR|=0x000000ff;	//    

//----------------------------------------------------
 //  
	FIO2SET|=(0x000000ff&data_up);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------

	FIO2CLR|=0x000000ff;	// 

//----------------------------------------------------
  //  
	FIO2SET|=(0x000000ff&data_low);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 

	FIO1SET|= _BV(TFT_RS);	//  

	FIO1SET|= _BV(TFT_CS); //  

	return;
}

void TFT_write_dat (unsigned int data)	
{
	unsigned char data_up=0,data_low=0;

	FIO1CLR|= _BV(TFT_CS); //  

	FIO1SET|= _BV(TFT_RS);	//  
	
	FIO1SET|= _BV(TFT_RD);
	FIO1SET|= _BV(TFT_WR);

	data_up=(data&0xff00)>>8;
	data_low=(data&0x00ff);

	FIO2CLR|=0x000000ff;	// 
//----------------------------------------------------
 //  
	FIO2SET|=(0x000000ff&data_up);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------
	FIO2CLR|=0x000000ff;	// 
//----------------------------------------------------
  //  
	FIO2SET|=(0x000000ff&data_low);

	FIO1CLR|= _BV(TFT_WR);  // 
	pause (10);
	FIO1SET|= _BV(TFT_WR);	// 
//----------------------------------------------------
	FIO1SET|= _BV(TFT_RS);	//  

	FIO1SET|= _BV(TFT_CS); //  

	return;
}

/*
unsigned int TFT_read_dat (void)
{

}	
*/
void SetReg(unsigned int index, unsigned int data)
{
	TFT_write_com (index);	
	TFT_write_dat (data);	
	return;
}

void PutPixel(unsigned int x, unsigned int y)
{
	unsigned int address;


//#if (DISP_ORIENTATION == 0)

    address = 0x100*y + x;

//#else

  //  y = GetMaxY() - y;
  //  address = (long)LINE_MEM_PITCH*x + y;

//#endif

    FIO1CLR|= _BV(TFT_CS); //  

// set addr
	TFT_write_com(0x0020);TFT_write_dat(address);   
	TFT_write_com(0x0021);TFT_write_dat(address);   
   
	TFT_write_com(0x0022);  //16 bit       
//
   	TFT_write_dat(0xffff);
	  
	FIO1SET|= _BV(TFT_CS); //  
}	

void TFT_init (void)
{
   //----------Display control ------------------
	TFT_write_com(0x0000);TFT_write_dat(0x0000);  
	TFT_write_com(0x00A4);TFT_write_dat(0x0001); 
	delay(70000);
	TFT_write_com(0x0007);TFT_write_dat(0x0001); 
	delay(500000);
	TFT_write_com(0x0012);TFT_write_dat(0x0000);

   //=====================   Gamma   =========================// CMO   
	TFT_write_com(0x0030);TFT_write_dat(0x0707);       
	TFT_write_com(0x0031);TFT_write_dat(0x0607);       
	TFT_write_com(0x0032);TFT_write_dat(0x0301);       
	TFT_write_com(0x0033);TFT_write_dat(0x0303);     
	TFT_write_com(0x0034);TFT_write_dat(0x0303);       
	TFT_write_com(0x0035);TFT_write_dat(0x0507);        
	TFT_write_com(0x0036);TFT_write_dat(0x021F);   
	TFT_write_com(0x0037);TFT_write_dat(0x0705);      
	TFT_write_com(0x0038);TFT_write_dat(0x0607);      
	TFT_write_com(0x0039);TFT_write_dat(0x0301);   
	TFT_write_com(0x003A);TFT_write_dat(0x0303);     
	TFT_write_com(0x003B);TFT_write_dat(0x0202);     
	TFT_write_com(0x003C);TFT_write_dat(0x0105);       
	TFT_write_com(0x003D);TFT_write_dat(0x021F);  
   
	delay(25000);

//------------------ Panel Image Control ---------------//   
	TFT_write_com(0x0050);TFT_write_dat(0x0000);       
	TFT_write_com(0x0051);TFT_write_dat(0x00EF);       
	TFT_write_com(0x0052);TFT_write_dat(0x0000);       
	TFT_write_com(0x0053);TFT_write_dat(0x013F);       
	TFT_write_com(0x0060);TFT_write_dat(0x2700);      
	TFT_write_com(0x0061);TFT_write_dat(0x0001);     
	TFT_write_com(0x006A);TFT_write_dat(0x0000);       
    
//-------------- Panel Interfcae Control ---------//     
   
	TFT_write_com(0x0090);TFT_write_dat(0x000F);   
	TFT_write_com(0x0092);TFT_write_dat(0x0001);   
	TFT_write_com(0x0093);TFT_write_dat(0x0001);   
	TFT_write_com(0x0095);TFT_write_dat(0x0110);   
   
   
//------------ Power Control --------------//  Jason@ 2007-6-29 ƶPowerģ򣺽ѹ   
	TFT_write_com(0x0017);TFT_write_dat(0x0001);   
	delay(500000);    
	TFT_write_com(0x0010);TFT_write_dat(0x17A0);   
	delay(500000);    
	TFT_write_com(0x0011);TFT_write_dat(0x0007);       
	TFT_write_com(0x0012);TFT_write_dat(0x013C);         
	delay(500000);   
	TFT_write_com(0x0013);TFT_write_dat(0x1300);         
	delay(500000);     
	TFT_write_com(0x0028);TFT_write_dat(0x0000);       
	TFT_write_com(0x0029);TFT_write_dat(0x0010);         
	TFT_write_com(0x002A);TFT_write_dat(0x0000);    
	TFT_write_com(0x0001);TFT_write_dat(0x0100);       
	delay(500000);    
	TFT_write_com(0x0002);TFT_write_dat(0x0700);       
	TFT_write_com(0x0003);TFT_write_dat(0x5230);       
	TFT_write_com(0x0008);TFT_write_dat(0x0207);      
	TFT_write_com(0x0009);TFT_write_dat(0x0000);      
	TFT_write_com(0x000A);TFT_write_dat(0x0008);      
   
   
//-------display on function --------------   
	TFT_write_com(0x0007);TFT_write_dat(0x0021);   
	delay(50000);     
	TFT_write_com(0x0007);TFT_write_dat(0x0061);   
	delay(50000);      
	TFT_write_com(0x0007);TFT_write_dat(0x0173);   
	delay(50000);       
	TFT_write_com(0x0017);TFT_write_dat(0x0000);   
   
  
//--------------write to GRAM ------------------//   
	TFT_write_com(0x0020);TFT_write_dat(0x0000);   
	TFT_write_com(0x0021);TFT_write_dat(0x0000);   
   
	TFT_write_com(0x0022);  //16 bit 


	return;
}
