#include <LPC23xx.H>
#include "cpu_conf.h"
#include "common.h"
#include "LS020.h"
#include "graph.h"
#include "scenar.h"
#include "TFT_R61505.h"


unsigned char k_menu=1,k_sleep=0;
unsigned char AM_mode=0,FM_mode=0,GAP_mode=0,INT_mode=0,DMP_mode=0;

unsigned char intens=1, dmp_val=0,dmp_tmp=0;

//unsigned char f_flag=0;
unsigned char abc;

unsigned int i_f=0,i_a=0,i_int=0,i_dmp,i_gap;
unsigned int mag_tmp=1,fr_tmp=10,intens_tmp=1,gap_tmp=200;

volatile unsigned int fr_val=50,mag_val=1,gap_val=200;

unsigned char i_intens;

unsigned char n_phase;

volatile unsigned int T_phase_1,T_phase_2;
//#################################################################################
void selection_off(void);
void menu (unsigned char k_menu);
void menu_plus (void);
void menu_minus (void);

void AM_modulation (unsigned char AM_mode);
void AM_mod_ind (unsigned char AM_mode);

void FM_modulation (unsigned char FM_mode);
void FM_mod_ind (unsigned char FM_mode);

int rand (int seed);

void INT_mod_ind (unsigned char intens);
void INT_modulation (unsigned char INT_mode);

void GAP_mode_ind (unsigned char GAP_mode);
void GAP_modulation (unsigned char GAP_mode);

void DMP_set_val (unsigned char dmp_tmp);
void DMP_ind (unsigned char	dmp_val);
void DMP_modulation (unsigned char DMP_mode);
//#################################################################################

/*
void PWM_COMP_vect (void) __irq
{	
	switch (intens_tmp)
	{
		case 1:
		 	PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);
			break;
		case 2: 
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>1)	i_intens=0;
			break;
		case 3:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==2) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>2)	i_intens=0;
			break;
		case 4:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==2) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==3) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>3)	i_intens=0;
			break;
		case 5:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==2) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==3) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==4) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>4)	i_intens=0;
			break;
		case 6:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==2) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==3) {PWM_set_val (0x06*mag_val+0x06*gap_val, 0x06*mag_tmp);}
			if (i_intens==4) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==5) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>5)	i_intens=0;
			break;
		case 7:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==2) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==3) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==4) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==5) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==6) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>6)	i_intens=0;
			break;
		case 8:
			if (i_intens==0) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==1) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==2) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==3) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==4) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==5) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}
			if (i_intens==6) {PWM_set_val (0x06*mag_tmp+0x06*gap_tmp, 0x06*mag_tmp);}	
			if (i_intens==7) {PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);}
			i_intens++;
			if (i_intens>7)	i_intens=0;
			break;
		default:
			PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);
			break;
	}

	T1TCR |=_BV(1);	//  
	T1TCR =0x01;	//   

	n_phase=0;

	PWM1IR |= _BV(0);
	T1IR|=_BV(4);

	VICVectAddr = 0;


	return;
}

void T0COMP_vect (void) __irq	 // 500    ,  
{

	AM_modulation(AM_mode);

	FM_modulation(FM_mode);

	INT_modulation (INT_mode);

	GAP_modulation (GAP_mode);

	DMP_modulation (DMP_mode);



	T0IR|=_BV(3);

	T1IR|=_BV(4);

	VICVectAddr = 0;
	return;
}


void T1Capt_vect (void) __irq
{

    T1TC=0;
    n_phase++;
		 
    if (n_phase==2)	  T_phase_1=T1CR0;

    if (n_phase==3)   T_phase_2=T1CR0;



	T1IR|=_BV(4);
	VICVectAddr = 0;
	return;
}


void T3COMP_vect (void) __irq	 //  Sleep
{
	
	if (keyP2(11)==0) 
	{
		FIO1CLR|= _BV(ONA);
	}

	T3TCR&=~_BV(1); T3TCR&=~_BV(0);	//   

	T3IR|=_BV(4);

	VICVectAddr = 0;
	return;
}
*/
int main()
{
 	SCS |= _BV(0);

	cpu_clocking_init (12, 1, 12,6);

	cpu_io_init();
	
	pow_init ();
	/*
	VICVectAddr8 = (unsigned)PWM_COMP_vect;
	VICVectPriority8 = 0x02;
	VICVectCntl8=0x0f;
	VICIntEnable|=_BV(8);


	VICVectAddr4 = (unsigned)T0COMP_vect;
	VICVectPriority4 = 0x03;
	VICVectCntl4=0x0f;
	VICIntEnable|=_BV(4);

	VICVectAddr27 = (unsigned)T3COMP_vect;
	VICVectPriority27 = 0x04;
	VICVectCntl27=0x0f;
	VICIntEnable|=_BV(27);

	
	VICVectAddr5 = (unsigned)T1Capt_vect;
	VICVectPriority5 = 0x01;
	VICVectCntl5=0x0f;
	VICIntEnable|=_BV(5);
	


	TC_conf ();	 //  



	delay(4800000);

   	if (keyP2(11)==0)  FIO1SET|= _BV(ONA);	
	
	FIO1CLR|= _BV(pow_dn); 	//  9v 



	mag_val= 1;
	fr_val=60;

 	AM_mode=0;
	FM_mode=0;

	GAP_mode=0;				

	dmp_val=15;

	T0_set_fr (500); // 500    ,  

	PWM_conf ();//   

	PWM_set_val (6000000/fr_tmp, 0x06*mag_tmp);		//  

   */

	TFT_port_init ();

	TFT_reset ();
   
	TFT_init ();      





	
	while (1)
	{	
		//TFT_write_com(0xa55a);
	//	pause(1000) ;	// 100 mks
		
		if (keyP2(11)==0) 
			
		{
			//T3TCR&=~_BV(1); T3TCR|=_BV(0);	//   
		}

		//if (keyP2(11)==1) T3TCR&=~_BV(1); T3TCR&=~_BV(0);	//   	



		if (keyP1(20)==0)
		{

		}

		if (keyP1(21)==0)  	
		{

		}

		if (keyP1(22)==0)
		{
			
		}

			
	}
}

void selection_off(void)
{
		LCD_Rectangle(1, 114, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 98, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 82, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 66, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 50, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 34, 17, 44,RGB_GREEN);
		LCD_Rectangle(1, 18, 17, 44,RGB_GREEN);	
		LCD_Rectangle(1, 2, 17, 44,RGB_GREEN);
	return;
}
void menu (unsigned char k_menu)
{
	if (k_menu==0)
	{
		selection_off();
	}
	if (k_menu==1)
	{
		selection_off();
		LCD_Rectangle(1, 114, 17, 44,RGB_RED);
	}
	if (k_menu==2)
	{
		selection_off();	
		LCD_Rectangle(1, 98, 17, 44,RGB_RED);
	}
	if (k_menu==3)
	{
		selection_off();	
		LCD_Rectangle(1, 82, 17, 44,RGB_RED);
	}		
	if (k_menu==4)
	{
		selection_off();	
		LCD_Rectangle(1, 66, 17, 44,RGB_RED);
	}
	if (k_menu==5)
	{
		selection_off();	
		LCD_Rectangle(1, 50, 17, 44,RGB_RED);
	}
	if (k_menu==6)
	{
		selection_off();	
		LCD_Rectangle(1, 34, 17, 44,RGB_RED);
	}
	if (k_menu==7)
	{
		selection_off();	
		LCD_Rectangle(1, 18, 17, 44,RGB_RED);
	}
	if (k_menu==8)
	{
		selection_off();	
		LCD_Rectangle(1, 2, 17, 44,RGB_RED);
	}

	else
	{
	}
 	return;
}
void menu_plus (void)
{
 	 //  
	 if (k_menu==1)
	 {
	  	mag_val++;  if (mag_val>500) mag_val=500;
		gclcd_put_val_3dig(50, 115, mag_val ,RGB_BLACK, RGB_GREEN,0);
	 }

	 //  
	 if (k_menu==2)
	 {
		  AM_mode++; 
		  if (AM_mode>6)	AM_mode=6;
		  AM_mod_ind (AM_mode);
	 }
	 // FM
	 if (k_menu==3)
	 {
		  FM_mode++;
		  if (FM_mode>2)	FM_mode=2;
		  FM_mod_ind (FM_mode);
	 }
	//   
	 if (k_menu==4)
	 {
	  	fr_val++; 
		if(fr_val>500)	fr_val=500;
		gclcd_put_val_3dig(50, 68, fr_val ,RGB_BLACK, RGB_GREEN,0);
		
	 }
	 //  
	 if (k_menu==5)
	 {
	  	intens++;
		if (intens>12)	intens=12;
		INT_mod_ind (intens);
	 }
	 //    
	 if (k_menu==6)
	 {
	  	gap_val=gap_val+20;
		if (gap_val>1600)	gap_val=1600;
	   	gclcd_put_val_4dig(50, 36, gap_val ,RGB_BLACK, RGB_GREEN,0);
	 }

	 if (k_menu==7)
	 {
	  	if ((intens_tmp>1)|(INT_mode!=0))
		{
			GAP_mode++;
			if (GAP_mode>2) GAP_mode=2;
		}
		else  GAP_mode=0;
		GAP_mode_ind (GAP_mode);
	 }
	 //  
	 if (k_menu==8)
	 {
		dmp_val++;
		if (dmp_val>16)	dmp_val=16;
		DMP_ind (dmp_val);
	 }
	 return;
}
void menu_minus (void)
{
 	 //  
	 if (k_menu==1)
	 {
	  	mag_val--;  if (mag_val<1) mag_val=1;
		gclcd_put_val_3dig(50, 115, mag_val ,RGB_BLACK, RGB_GREEN,0);
	 }

	 //  
	 if (k_menu==2)
	 {

	 	  AM_mode--; 
		  if (AM_mode>6)	AM_mode=0;
		  AM_mod_ind (AM_mode);
	 }
	 // FM
	 if (k_menu==3)
	 {
		  FM_mode--;
		  if (FM_mode>2)	FM_mode=0;
		  FM_mod_ind (FM_mode);
	 }
	//   
	 if (k_menu==4)
	 {
	  	fr_val--; 
		if(fr_val<1)	fr_val=1;
		gclcd_put_val_3dig(50, 68, fr_val ,RGB_BLACK, RGB_GREEN,0);

	 }
	 //  
	 if (k_menu==5)
	 {
	  	intens--;
		if (intens<1)	
			intens=1;
		INT_mod_ind (intens);
	 }
	 //    
	 if (k_menu==6)
	 {
	  	gap_val=gap_val-20;
		if (gap_val<200)	gap_val=200;
	   	gclcd_put_val_4dig(50, 36, gap_val ,RGB_BLACK, RGB_GREEN,0);
	 }
	 if (k_menu==7)
	 {
	  	if ((intens_tmp>1)|(INT_mode!=0))
		{
			GAP_mode--;
			if (GAP_mode>2) GAP_mode=0;
		}
		else  GAP_mode=0;
		GAP_mode_ind (GAP_mode);

	 }
	 //  
	 if (k_menu==8)
	 {
		dmp_val--;
		if (dmp_val>16)	dmp_val=0;
		DMP_ind (dmp_val);
	 }

	 return;
}

void AM_modulation (unsigned char AM_mode)
{
	if (AM_mode==0)
	{
		mag_tmp=mag_val;	
	}
	if (AM_mode==1)
	{
		i_a++;
		if (i_a<=500) 				mag_tmp= (i_a*(mag_val)/500) +1;
		if ((i_a>500)&(i_a<1000))	mag_tmp= (((1000-i_a)*mag_val)/500)+1;
		if (i_a>=1000)	i_a=0;
	}
	if (AM_mode==2)
	{
		i_a++;
		if (i_a<=725) 				mag_tmp= (i_a*(mag_val)/725) +1;
		if ((i_a>725)&(i_a<1500))	mag_tmp= (((1500-i_a)*mag_val)/725)+1;
		if (i_a>=1500)	i_a=0;
	}
  	if (AM_mode==3)
	{
		i_a++;
		if (i_a<=500) 				mag_tmp= (i_a*(mag_val)/500) +1;
		if ((i_a>500)&(i_a<1000))	mag_tmp= (((1000-i_a)*mag_val)/500)+1;
		if ((i_a>=1000)&(i_a<2000))	mag_tmp=1;
		if (i_a>=2000)	i_a=0;
	}
	if (AM_mode==4)
	{
		i_a++;
		if (i_a<=500) 				mag_tmp= (i_a*(mag_val)/500) +1;
		if ((i_a>500)&(i_a<1000))	mag_tmp= (((1000-i_a)*mag_val)/500)+1;
		if ((i_a>=1000)&(i_a<2500))	mag_tmp=1;
		if (i_a>=2500)	i_a=0;
	}
	if (AM_mode==5)
	{
		i_a++;
		if (i_a<=500) 				mag_tmp= (i_a*(mag_val)/500) +1;
		if ((i_a>500)&(i_a<1000))	mag_tmp= (((1000-i_a)*mag_val)/500)+1;
		if ((i_a>=1000)&(i_a<3000))	mag_tmp=1;
		if (i_a>=3000)	i_a=0;
	}
	if (AM_mode==6)
	{
		i_a++;
		if (i_a<=500) 				mag_tmp= (i_a*(mag_val)/500) +1;
		if ((i_a>500)&(i_a<1000))	mag_tmp= (((1000-i_a)*mag_val)/500)+1;
		if ((i_a>=1000)&(i_a<3500))	mag_tmp=1;
		if (i_a>=3500)	i_a=0;
	}
	return;
}

void AM_mod_ind (unsigned char AM_mode)
{
		switch (AM_mode)
		{
			case 0: 
				gclcd_put_txt (50,100," none  ", RGB_BLACK,RGB_GREEN,0);
				break;
			case 1: 
				gclcd_put_txt (50,100,"1:1SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			case 2: 
				gclcd_put_txt (50,100,"1:2SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			case 3: 
				gclcd_put_txt (50,100,"1:3SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			case 4: 
				gclcd_put_txt (50,100,"1:4SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			case 5: 
				gclcd_put_txt (50,100,"1:5SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			case 6: 
				gclcd_put_txt (50,100,"1:6SAW", RGB_BLACK,RGB_GREEN,0);
				break;
			default:
				break;
		}
	return;
}

void FM_modulation (unsigned char FM_mode)
{
	if (FM_mode==0)
	{	  
		fr_tmp=fr_val; // .   
	}
	
	if (FM_mode==1)	// 
	{
		i_f++;

		if (i_f<=1750)
		{
		 	if (i_f%5==0)	fr_tmp=(i_f/7)+10;
		}

		if ((i_f>1750)& (i_f<=3500))
		{	
			if (i_f%5==0)	fr_tmp=((3500-i_f)/7)+10;			
		}
		if (i_f>3500)
		{
		   	i_f=0;
			fr_tmp=10;
		}	
	}
	if (FM_mode==2)
	{
	   i_f++;
	   if (i_f>100)	
	   {
	   		i_f=0;
			fr_tmp=(0x1FF&rand(0xffff))+10;
	   }
	}
	return;
}

void FM_mod_ind (unsigned char FM_mode)
{
		switch (FM_mode)
		{
			case 0: 
				gclcd_put_txt (50,84," none", RGB_BLACK,RGB_GREEN,0);
				break;
			case 1: 
				gclcd_put_txt (50,84," SAW ", RGB_BLACK,RGB_GREEN,0);
				break;
			case 2: 
				gclcd_put_txt (50,84," Rnd ", RGB_BLACK,RGB_GREEN,0);
				break;
			default:
				break;
		}
	return;
}

void INT_mod_ind (unsigned char intens)
{
		switch (intens)
		{
			case 1: 
				INT_mode=0;
				intens=1;
				GAP_mode=0;
				GAP_mode_ind (GAP_mode);
				gclcd_put_txt(50, 52, " 1  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 2: 
				INT_mode=0;
				intens=2;
				gclcd_put_txt(50, 52, " 2  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 3: 
				INT_mode=0;
				intens=3;
				gclcd_put_txt(50, 52, " 3  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 4: 
				INT_mode=0;
				intens=4;
				gclcd_put_txt(50, 52, " 4  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 5: 
				INT_mode=0;
				intens=5;
				gclcd_put_txt(50, 52, " 5  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 6: 
				INT_mode=0;
				intens=6;
				gclcd_put_txt(50, 52, " 6  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 7: 
				INT_mode=0;
				intens=7;
				gclcd_put_txt(50, 52, " 7  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 8: 
				INT_mode=0;
				intens=8;
				gclcd_put_txt(50, 52, " 8  " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 9: 
				INT_mode=1;
				intens=1;
				gclcd_put_txt(50, 52, "Var1" ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 10: 
				INT_mode=2;
				intens=1;	
				gclcd_put_txt(50, 52, "Var2" ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 11: 
				INT_mode=3;
				intens=1;	
				gclcd_put_txt(50, 52, "Rnd1" ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 12: 
				INT_mode=4;
				intens=1;	
				gclcd_put_txt(50, 52, "Rnd2" ,RGB_BLACK, RGB_GREEN,0);
				break;
			default:
				break;
		}
	return;
} 

void INT_modulation (unsigned char INT_mode)
{
	if (INT_mode==0)
	{
	 	intens_tmp=intens;
	}

	if (INT_mode==1)
	{
		 i_int++;
		 if (i_int<=750)
		 {
		 	intens_tmp=(i_int/200)+1;
		 }

		 if ((i_int>750)&(i_int<=1500))
		 {
			intens_tmp=((1500-i_int)/200)+1;
		 }
		 if(i_int>1500)	
		 {
		 	i_int=0;
			intens_tmp=1;
		 }
	}

	if (INT_mode==2)
	{
		 i_int++;
		 if (i_int<=750)
		 {
		 	intens_tmp=(i_int/200)+4;
		 }

		 if ((i_int>750)&(i_int<=1500))
		 {
			intens_tmp=((1500-i_int)/200)+4;
		 }
		 if(i_int>1500)	
		 {
		 	i_int=0;
			intens_tmp=1;
		 }
	}

	if (INT_mode==3)
	{
		   i_int++;
		   if (i_int>=450)
		   {
				i_int=0;
				intens_tmp=(0x03&rand(0x03))+1;
		   }
	}
	if (INT_mode==4)
	{
		   i_int++;
		   if (i_int>=450)
		   {
				i_int=0;
				intens_tmp=(0x03&rand(0x03))+4;
		   }
	}
 	return;
}
void GAP_mode_ind (unsigned char GAP_mode)
{
	switch (GAP_mode)
		{
			case 0: 
				gclcd_put_txt(50, 20, "none" ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 1: 
				gclcd_put_txt(50, 20, "Var " ,RGB_BLACK, RGB_GREEN,0);
				break;
			case 2: 
				gclcd_put_txt(50, 20, "Rnd " ,RGB_BLACK, RGB_GREEN,0);
				break;
			default:
				break;
		}
	return;
}
void GAP_modulation (unsigned char GAP_mode)
{
	if (GAP_mode==0)
	{
		gap_tmp=gap_val;
	}
	if (GAP_mode==1)
	{
		i_gap++;
		if (i_gap<1250)
		{
			gap_tmp=((i_gap*1400)/1250)+200;
		}
		if ((i_gap>=1250)&(i_gap<2500))
		{
			gap_tmp=(((2500-i_gap)*1400)/1250)+200;
		}
		if(i_gap>=2500)
		{	
			i_gap=0;
			gap_tmp=200;
		}
	}
	if (GAP_mode==2)
	{
		i_gap++;
		if(i_gap>=350)
		{
		 	i_gap=0;
			gap_tmp=(0x5ff&rand(0x5ff))+200;
		}
	}
	return;						   
}

void DMP_set_val (unsigned char dmp_v)
{
	switch (dmp_v)
	{	
		case 0: 
			FIO1SET|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;	
		case 1: 
			FIO1CLR|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 2: 
			FIO1CLR|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 3: 
			FIO1CLR|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 4: 
			FIO1CLR|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 5: 
			FIO1CLR|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 6: 
			FIO1CLR|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 7: 
			FIO1CLR|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 8: 
			FIO1SET|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 9: 
			FIO1SET|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break; 
		case 10: 
			FIO1SET|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 11: 
			FIO1SET|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 12: 
			FIO1SET|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 13: 
			FIO1SET|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3SET|= _BV(dmp0);
			break;
		case 14: 
			FIO1SET|= _BV(dmp3);
			FIO0SET|= _BV(dmp2);
			FIO0SET|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		case 15: 
			FIO1CLR|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
		default:
			FIO1CLR|= _BV(dmp3);
			FIO0CLR|= _BV(dmp2);
			FIO0CLR|= _BV(dmp1);
			FIO3CLR|= _BV(dmp0);
			break;
	}
	return;	
}

void DMP_ind (unsigned char	dmp_val)
{
	switch (dmp_val)
	{
		case 0: 
			DMP_mode=0;
			dmp_val=0;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 1  " ,RGB_BLACK, RGB_GREEN,0);
			break;	
		case 1: 
			DMP_mode=0;
			dmp_val=15;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 2  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 2: 
			DMP_mode=0;
			dmp_val=1;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 3  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 3: 
		  	DMP_mode=0;
			dmp_val=2;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 4  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 4: 
			dmp_val=3;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 5  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 5: 
			DMP_mode=0;
			dmp_val=4;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 6  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 6: 
			DMP_mode=0;
			dmp_val=5;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 7  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 7: 
			DMP_mode=0;
			dmp_val=6;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 8  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 8: 
			DMP_mode=0;
			dmp_val=7;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 9  " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 9: 
			DMP_mode=0;
			dmp_val=8;
			gclcd_put_txt(50, 4, " 10 " ,RGB_BLACK, RGB_GREEN,0);
			break; 
		case 10: 
			DMP_mode=0;
			dmp_val=9;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 11 " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 11: 
			DMP_mode=0;
			dmp_val=10;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 12 " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 12: 
			dmp_val=11;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 13 " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 13: 
			DMP_mode=0;
			dmp_val=12;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 14 " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 14: 
			DMP_mode=0;	
			dmp_val=13;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " 15 " ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 15: 
			DMP_mode=1;
			dmp_val=15;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " Var" ,RGB_BLACK, RGB_GREEN,0);
			break;
		case 16: 
			DMP_mode=2;
			dmp_val=15;
			DMP_set_val (dmp_val);
			gclcd_put_txt(50, 4, " Rnd" ,RGB_BLACK, RGB_GREEN,0);
			break;
		default:
			DMP_mode=1;
			dmp_val=15;
			DMP_set_val (dmp_val);
			break;
	}
	return;

}

void DMP_modulation (unsigned char DMP_mode)
{
	if (DMP_mode==0)
	{
		dmp_tmp=dmp_val;
		DMP_set_val (dmp_tmp);	
	}
	if (DMP_mode==1)
	{
	 	i_dmp++;
		if (i_dmp<=2250) DMP_set_val (i_dmp/150);

		if ((i_dmp>2250)&(i_dmp<=4500)) DMP_set_val ((4500-i_dmp)/150);	

		if (i_dmp>4500)	{i_dmp=0; DMP_set_val (0);}	
	}
	if (DMP_mode==2)
	{
	 	i_dmp++;
		if (i_dmp>150)
		{
			i_dmp=0;
			DMP_set_val(0x0e&rand(0xffff));	
		}
	}
	return;
}
